{
Dieses Programm und der Quelltext ist Freeware.
Dieser Quelltext zeigt wie man zur Laufzeit Komponenten
erstellt und mit diesen arbeitet.

Viel Spa wnscht Ihr Programming24.net Team.

/---------------------------------------------------\
| WWW.Programming24.net                             |
| Delphi-Sektion: delphi@programming24.net          |
| VB- und CPP- Sektion: webmaster@programming24.net |
\---------------------------------------------------/
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    function Berechne: boolean;
    procedure MaleBackground;
  end;

var
  Form1: TForm1;
  LKiloPreis, LGewicht, LTara, LEVP, LLinie: TLabel; // Hier werden alle Labels deklariert
  EKiloPreis, EGewicht, ETara: TEdit; // Hier werden alle Edits deklariert
  img: TImage; // Hier wird das Hintergrundimage deklariert

implementation

{$R *.DFM}

procedure TForm1.MaleBackground;
var x,y: integer;
begin
  { Diese Funktion malt auf das Image ein Farbeverlauf }
  for x := 0 to form1.ClientWidth do begin
      for y := 0 to Form1.ClientHeight do begin
          img.Canvas.Pixels[x,y] := rgb(220,220,255-((255 div ClientHeight) * y));
      end;
  end;
end;

function TForm1.Berechne: boolean;
var Kilo, Gew, tara, EVP: single;
begin
  result := false;
  Kilo := strtofloat(EkiloPreis.text); // Schreibt den Text von Edit "EKiloPreis" in "Kilo" als Float
  Gew := strtofloat(EGewicht.text); // Schreibt den Text von Edit "EGewicht" in "Gew" als Float
  Tara := strtofloat(ETara.text); // Schreibt den Text von Edit "ETara" in "Kilo" als Tara
  if tara < Gew then begin // Wenn Gewicht grer als Tara dann rechne
     EVP := (kilo/1000) * (Gew - tara); // Berechnet den EVP-Preis
     if EVP >= 0 then begin
        result := true;
        LEVP.Caption := format('%.2f  EVP',[EVP]); // Ausgabe in Label "LEVP"
     end
     else showmessage('Bitte berprfen Sie Ihre Eingaben.'#13'Der Preis ist unter 0 .');
  end
  else Showmessage('Tara ist Grer / Gleich als das Gesammtgewicht?'#13'Bitte korigieren Sie diese.');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Initilisierung der Komponenten }
  LKiloPreis := TLabel.Create(self); // Speicher Reservierung fr LKiloPreis und als TLabel erstellt
  with LKiloPreis do begin // Bearbeiten der LKiloPreis Eigenschaften
       Caption := 'Kilopreis in :';
       Left := 5;
       Top := 5;
       Parent := Form1; // Parent = Eltern      d.h. Das Label wird auf ein Formular drauf gemalt. kann auch auf ein Panel ( TWinControl )
       transparent := true;
  end;
  EKiloPreis := TEdit.Create(self);
  with EKiloPreis do begin
       Text := '0,00';
       Left := 5;
       Top := LkiloPreis.Height + LKilopreis.Top + 5;
       Parent := Form1;
       OnKeyPress := EditKeyPress;  // Zuweisen des Ereignisses EditKeyPress zu OnKeyPress
  end;

  LGewicht := TLabel.Create(self);
  with LGewicht do begin
       Caption := 'Gewicht in Gram:';
       Left := 5;
       Top := EkiloPreis.Height + EKilopreis.Top + 5;;
       Parent := Form1;
       transparent := true;
  end;
  EGewicht := TEdit.Create(self);
  with EGewicht do begin
       Text := '0,00';
       Left := 5;
       Top := LGewicht.Height + LGewicht.Top + 5;
       Parent := Form1;
       OnKeyPress := EditKeyPress;
  end;

  LTara := TLabel.Create(self);
  with LTara do begin
       Caption := 'Tara in Gram:';
       Left := 5;
       Top := EGewicht.Height + EGewicht.Top + 5;
       Parent := Form1;
       transparent := true;
  end;
  ETara := TEdit.Create(self);
  with ETara do begin
       Text := '0,00';
       Left := 5;
       Top := LTara.Height + LTara.Top + 5;
       Parent := Form1;
       OnKeyPress := EditKeyPress;
  end;

  LLinie := TLabel.Create(self);
  with LLinie do begin
       Caption := '=';
       Left := -1;
       Top := ETara.Height + ETara.Top+5;
       Parent := Form1;
       transparent := true;
  end;

  Form1.clientwidth := 130+5;
  Form1.clientheight := 168+5;

  while LLinie.Width < Form1.Width do
        LLinie.caption := LLinie.caption+'='; // Zieht eine Abschlusslinier von Links nach Rechts

  LEVP := TLabel.Create(self);
  with LEVP do begin
       Caption := '0,00  EVP';
       Left := 5;
       autosize := false;
       Alignment := taCenter;
       width := Form1.clientWidth - 5;
       Top := ETara.Height + ETara.Top + 5;
       font.Size := 10;
       font.Style := [fsbold, fsunderline];
       top := LLinie.Height + LLinie.top + 5;
       Parent := Form1;
       transparent := true;
  end;

  Form1.caption := 'Verkaufspreis';
  Form1.Position := poDesktopCenter;
  form1.BorderStyle := bsToolWindow;

  img := Timage.Create(self);
  with img do begin
       Align := alclient;
       parent := Form1;
       SendToBack;  // Zeichnet Das Bild hinter allen Komponenten (Hintergrund)
  end;

  MaleBackground; // Funktion Hintergrund auf Image Zeichnen
end;

procedure TForm1.EditKeyPress(Sender: TObject; var Key: Char);
begin
  { berprft die Eingaben aller Eingabefelder "Edits" die mit OnKeyPress verlinkt wurden }
  case key of
           '0'..'9',#8: key := key; // Zahlen und Backspace = nichts machen
           ','..'.': begin
                       if pos(',', TEdit(Sender).text) > 0 then // berprft ob Komma schon drinne ist
                          key := #0 // Wenn schon drinn dann wird key auf 0 gesetzt    d.h. Als htte man keine Taste gedrckt
                       else key := ','; // Ansonsten Komma hinzufgen, hat den vorteil wenn einer Punkt eingibt wird es durch Komma ersetzt
                     end;
           #13: begin // Bei Enter
                  if (trim(TEdit(Sender).text) = ',') or (trim(TEdit(Sender).text) = '') then // Nur Wenn kein leeres Feld oder Komma alleine drinne steht
                     Showmessage('Der eingegebene Wert ist ungltig.')
                  else begin
                    if Sender = EKiloPreis then // berprft das Element wo die Taste gedrckt wird
                       EGewicht.SetFocus; // Setzt das Focus auf das Nchste Feld
                    if Sender = EGewicht then
                       ETara.SetFocus;
                    if Sender = ETara then begin
                       Berechne;  // Berechnet die Werte (siehe oben)
                       EKiloPreis.SetFocus;
                    end;
                  end;
                end;
  else key := #0; // Wenn Buchstabe oder sonstiges eingegeben wird gebe keine Taste zurck (nichts gedrckt :-) )
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  { Nun noch die Komponenten wieder Freigeben }
  LEVP.free;
  LGewicht.free;
  llinie.free;
  LKiloPreis.free;
  LTara.free;

  EGewicht.free;
  EKiloPreis.free;
  ETara.free;

  img.free;
end;

end.
